package com.bpcl.lpg.core.service;

import com.bpcl.lpg.facades.bda.data.LpgBdaReturnEmptyCylinderResponseData;
import com.bpcl.lpg.facades.bda.data.LpgAcknowledgeResponseData;
import com.bpcl.lpg.facades.bda.data.BdaAuthenticationResponseData;
import com.bpcl.lpg.facades.bda.data.LpgCreateIndentResponseData;
import com.bpcl.lpg.facades.bda.data.LpgBdaStockResponseData;
import com.bpcl.lpg.core.model.BDADeliveryChallanModel;
import com.bpcl.lpg.core.model.LpgDeliveryAssistantModel;
import com.bpcl.lpg.facades.data.LpgBDADeliveryConfirmResponseData;
import com.bpcl.lpg.facades.data.LpgBDADeliveryConfirmRequestData;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.bpcl.lpg.core.pojo.RspResponseData;
import com.bpcl.lpg.facades.safetyInspection.data.CustomerDetailsRequestData;

public interface LpgBDAService
{
    void populateRequestData(final CustomerDetailsRequestData p0);
    
    RspResponseData getCustomerDetailsFromLpg(final CustomerDetailsRequestData p0) throws JsonProcessingException;
    
    LpgBDADeliveryConfirmResponseData getDeliveryConfirmationFromLpg(final LpgBDADeliveryConfirmRequestData p0) throws JsonProcessingException;
    
    LpgDeliveryAssistantModel getBDADetailsByUid(final String p0);
    
    BDADeliveryChallanModel getBdaDeliveryChallan(final String p0);
    
    BDADeliveryChallanModel getBdaDeliveryChallanByMobileNo(final String p0);
    
    void populateDeliveryConfirmationRequestData(final LpgBDADeliveryConfirmRequestData p0);
    
    LpgBdaStockResponseData getBDAStockDetails(final String p0) throws JsonProcessingException;
    
    LpgCreateIndentResponseData createIndent(final String p0, final String p1, final LpgDeliveryAssistantModel p2) throws JsonProcessingException;
    
    BdaAuthenticationResponseData getBDADetailsFromLpg(final String p0) throws JsonProcessingException;
    
    void createDeliveryAssistant(final BdaAuthenticationResponseData p0, final String p1, final Boolean p2, final LpgDeliveryAssistantModel p3);
    
    LpgAcknowledgeResponseData acknowledgeDeliveryChallan(final String p0, final String p1) throws JsonProcessingException;
    
    LpgBdaReturnEmptyCylinderResponseData createReturnRequestForCylinder(final String p0, final String p1, final String p2) throws JsonProcessingException;
    
    boolean doesBdaExist(final String p0);
}
